/*
 * Note: this file originally auto-generated by mib2c using
 *        mib2c.brcm.iterate.conf 2003/6/16 turcotte 
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "docsDevFilterIpTable.h"

/** Initialize the docsDevFilterIpTable table by defining its contents and how it's structured */
void
initialize_table_docsDevFilterIpTable(void)
{
    static oid      docsDevFilterIpTable_oid[] =
        { 1, 3, 6, 1, 2, 1, 69, 1, 6, 4 };
    netsnmp_handler_registration *my_handler;

    /*
     * create the table structure itself 
     */

    /*
     * if your table is read only, it's easiest to change the
     * HANDLER_CAN_RWRITE definition below to HANDLER_CAN_RONLY 
     */
    my_handler =
        netsnmp_create_handler_registration("docsDevFilterIpTable",
                                            docsDevFilterIpTable_handler,
                                            docsDevFilterIpTable_oid,
                                            OID_LENGTH
                                            (docsDevFilterIpTable_oid),
                                            HANDLER_CAN_RWRITE);

    if (my_handler) {
        if (netsnmp_register_handler(my_handler)) {
            DEBUGMSGTL(("initialize_table_docsDevFilterIpTable",
                        "Handler registration failed!\n"));
            return;
        }
    } else {
        DEBUGMSGTL(("initialize_table_docsDevFilterIpTable",
                    "Handler create failed!\n"));
        return;
    }
    DEBUGMSGTL(("initialize_table_docsDevFilterIpTable",
                "Handler created and registered.\n"));



}

/** Initializes the docsDevFilterIpTable module */
void
init_docsDevFilterIpTable(void)
{

    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_docsDevFilterIpTable();
}

/** handles requests for the docsDevFilterIpTable table */
int
docsDevFilterIpTable_handler(netsnmp_mib_handler *handler,
                             netsnmp_handler_registration *reginfo,
                             netsnmp_agent_request_info *reqinfo,
                             netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_variable_list *var;
    char           *tmpVal[MAX_OID_LEN * sizeof(oid)];
    size_t          tmpValLen;
    int             tmpAsnType, tmpOidLen;
    oid             tmpOid[MAX_OID_LEN];
    int             retVal = SNMP_ERR_NOERROR;

    for (request = requests; request; request = request->next) {
        var = request->requestvb;
        if (request->processed != 0)
            continue;

        /*
         * perform anything here that you need to do before each
         * request is processed. 
         */

        switch (reqinfo->mode) {
        case MODE_GET:
            retVal = v2Get(var->name, var->name_length, tmpVal,
                           &tmpValLen, reqinfo);
            if (retVal == SNMP_ERR_NOERROR) {
                switch (var->name[reginfo->rootoid_len + 1]) {
                case COLUMN_DOCSDEVFILTERIPSTATUS:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPCONTROL:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPIFINDEX:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDIRECTION:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPBROADCAST:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSADDR:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSMASK:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDADDR:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDMASK:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPPROTOCOL:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSOURCEPORTLOW:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSOURCEPORTHIGH:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDESTPORTLOW:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDESTPORTHIGH:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPMATCHES:
                    snmp_set_var_typed_value(var, ASN_COUNTER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPTOS:
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPTOSMASK:
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPCONTINUE:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPPOLICYID:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                default:
                    /*
                     * We shouldn't get here 
                     */
                    snmp_log(LOG_ERR,
                             "problem encountered in docsDevFilterIpTable_handler: unknown column\n");
                }
            } else {
                netsnmp_set_request_error(reqinfo, requests, retVal);
            }
            break;
        case MODE_GETNEXT:
            DEBUGMSGTL(("docsDevFilterIpTable_handler", "GETNEXT\n"));
            /*
             * Check to see if var is in this subtree. If not, just
             * get the first object by using rootoid.1.firstColumn 
             */
            if ((netsnmp_oid_is_subtree
                 (reginfo->rootoid, reginfo->rootoid_len, var->name,
                  var->name_length) == 0)
                && (var->name_length >= reginfo->rootoid_len + 2)) {
                DEBUGMSGTL(("docsDevFilterIpTable_handler",
                            "In Subtree - using var:\n"));
                tmpOidLen = var->name_length;
                memcpy((char *) tmpOid, (char *) var->name,
                       tmpOidLen * sizeof(oid));
                retVal =
                    v2GetNext(tmpOid, &tmpOidLen, reginfo->rootoid_len + 2,
                              tmpVal, &tmpValLen, reqinfo);
                if ((retVal == SNMP_ERR_NOSUCHNAME)
                    && (tmpOid[reginfo->rootoid_len + 1] < 20)) {
                    /*
                     * more columns to try 
                     */
                    tmpOidLen = reginfo->rootoid_len + 2;
                    tmpOid[tmpOidLen - 1] = tmpOid[tmpOidLen - 1] + 1;
                    retVal = v2GetNext(tmpOid, &tmpOidLen, tmpOidLen,
                                       tmpVal, &tmpValLen, reqinfo);
                }
            } else {            /* not in subtree */
                tmpOidLen = reginfo->rootoid_len;
                memcpy((char *) tmpOid, (char *) reginfo->rootoid,
                       tmpOidLen * sizeof(oid));
                tmpOid[tmpOidLen] = 1;
                tmpOidLen++;
                tmpOid[tmpOidLen] = 2;
                tmpOidLen++;
                retVal = v2GetNext(tmpOid, &tmpOidLen, tmpOidLen,
                                   tmpVal, &tmpValLen, reqinfo);
            }

            if (retVal == SNMP_ERR_NOERROR) {
                snmp_set_var_objid(var, tmpOid, tmpOidLen);
                switch (var->name[reginfo->rootoid_len + 1]) {
                case COLUMN_DOCSDEVFILTERIPSTATUS:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPCONTROL:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPIFINDEX:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDIRECTION:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPBROADCAST:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSADDR:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSMASK:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDADDR:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDMASK:
                    snmp_set_var_typed_value(var, ASN_IPADDRESS,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPPROTOCOL:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSOURCEPORTLOW:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPSOURCEPORTHIGH:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDESTPORTLOW:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPDESTPORTHIGH:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPMATCHES:
                    snmp_set_var_typed_value(var, ASN_COUNTER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPTOS:
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPTOSMASK:
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPCONTINUE:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;

                case COLUMN_DOCSDEVFILTERIPPOLICYID:
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (u_char *) tmpVal, tmpValLen);
                    break;


                default:
                    /*
                     * We shouldn't get here
                     */
                    snmp_log(LOG_ERR,
                             "problem encountered in docsDevFilterIpTable_handler: unknown column\n");

                }               /* switch on column */
            } else if (retVal == SNMP_ERR_NOSUCHNAME) {
                /*
                 * if V2 returns NOSUCH, netsnmp wants this handler
                 * to return NOERR, but we don't netsnmp_set_request_error
                 * or snmp_set_var_*. Tricky, tricky! 
                 */
                retVal = SNMP_ERR_NOERROR;
            } else {            /* retVal has a real error code */
                netsnmp_set_request_error(reqinfo, requests, retVal);
            }
            break;

        case MODE_SET_RESERVE1:
            printf
                ("docsDevFilterIpTable_handler: Mode = MODE_SET_RESERVE\n");
            switch (var->name[reginfo->rootoid_len + 1]) {
            case COLUMN_DOCSDEVFILTERIPSTATUS:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPCONTROL:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPIFINDEX:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPDIRECTION:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPBROADCAST:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPSADDR:
                if (requests->requestvb->type != ASN_IPADDRESS) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPSMASK:
                if (requests->requestvb->type != ASN_IPADDRESS) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPDADDR:
                if (requests->requestvb->type != ASN_IPADDRESS) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPDMASK:
                if (requests->requestvb->type != ASN_IPADDRESS) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPPROTOCOL:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPSOURCEPORTLOW:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPSOURCEPORTHIGH:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPDESTPORTLOW:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPDESTPORTHIGH:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPTOS:
                if (requests->requestvb->type != ASN_OCTET_STR) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPTOSMASK:
                if (requests->requestvb->type != ASN_OCTET_STR) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPCONTINUE:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            case COLUMN_DOCSDEVFILTERIPPOLICYID:
                if (requests->requestvb->type != ASN_INTEGER) {
                    netsnmp_set_request_error(reqinfo, requests,
                                              SNMP_ERR_WRONGTYPE);
                    retVal = SNMP_ERR_WRONGTYPE;
                } else {
                    retVal = v2Test(requests->requestvb->name,
                                    requests->requestvb->name_length,
                                    requests->requestvb->val.string,
                                    requests->requestvb->val_len,
                                    requests->requestvb->type, reqinfo);
                    if (retVal != SNMP_ERR_NOERROR)
                        netsnmp_set_request_error(reqinfo, requests,
                                                  retVal);
                }
                break;
            default:
                /*
                 * We shouldn't get here 
                 */
                snmp_log(LOG_ERR,
                         "problem encountered in docsDevFilterIpTable_handler: unknown column\n");
            }
            break;

        case MODE_SET_RESERVE2:
        case MODE_SET_ACTION:
        case MODE_SET_UNDO:
        case MODE_SET_FREE:
            break;
        case MODE_SET_COMMIT:
            printf
                ("docsDevFilterIpTable_handler: Mode = MODE_SET_COMMIT\n");
            /*
             * really do the set! 
             */
            switch (var->name[reginfo->rootoid_len + 1]) {
            case COLUMN_DOCSDEVFILTERIPSTATUS:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPCONTROL:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPIFINDEX:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPDIRECTION:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPBROADCAST:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPSADDR:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPSMASK:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPDADDR:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPDMASK:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPPROTOCOL:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPSOURCEPORTLOW:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPSOURCEPORTHIGH:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPDESTPORTLOW:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPDESTPORTHIGH:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPTOS:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPTOSMASK:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPCONTINUE:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            case COLUMN_DOCSDEVFILTERIPPOLICYID:

                retVal = v2Set(requests->requestvb->name,
                               requests->requestvb->name_length,
                               requests->requestvb->val.string,
                               requests->requestvb->val_len,
                               requests->requestvb->type, reqinfo);
                if (retVal != SNMP_ERR_NOERROR)
                    netsnmp_set_request_error(reqinfo, requests, retVal);
                break;
            default:
                /*
                 * We shouldn't get here 
                 */
                snmp_log(LOG_ERR,
                         "problem encountered in docsDevFilterIpTable_handler: unknown column\n");
            }

            break;


        default:
            snmp_log(LOG_ERR,
                     "problem encountered in _handler: unsupported mode\n");
        }
    }
    return retVal;
}
