/*	$OpenBSD: xmalloc.h,v 1.9 2002/06/19 00:27:55 deraadt Exp $	*/

/*
 * Author: Tatu Ylonen <ylo@cs.hut.fi>
 * Copyright (c) 1995 Tatu Ylonen <ylo@cs.hut.fi>, Espoo, Finland
 *                    All rights reserved
 * Created: Mon Mar 20 22:09:17 1995 ylo
 *
 * Versions of malloc and friends that check their results, and never return
 * failure (they call fatal if they encounter an error).
 *
 * As far as I am concerned, the code I have written for this software
 * can be used freely for any purpose.  Any derived versions of this
 * software must be clearly marked as such, and if the derived work is
 * incompatible with the protocol description in the RFC file, it must be
 * called by a name other than "ssh" or "Secure Shell".
 */
 
/****************************************************************************
*
* Portions of this software Copyright (c) 2015 Broadcom Corporation
*
****************************************************************************
*
* Filename: xmalloc.h
*
****************************************************************************
* Description:
* Linking malloc and friends in OpenSSH with BRCM OpenSSH memory management 
* code.
*
****************************************************************************/
#ifndef XMALLOC_H
#define XMALLOC_H

void * OpenSshLogMemoryAlloc (const char *file, int line, void * pMemory, unsigned int size  );
void OpenSshLogMemoryFree (unsigned char * pMemory );

#define xmalloc( _size ) OpenSshLogMemoryAlloc( __FILE__, __LINE__, xxmalloc( _size ), _size )
#define xstrdup( mem )  (char *)OpenSshLogMemoryAlloc( __FILE__, __LINE__, xxstrdup( mem ), strlen(mem) + 1 ) 

void	*xxmalloc(size_t);
void	*xrealloc(void *, size_t);
void     xfree(void *);
char	*xxstrdup(const char *);

#endif				/* XMALLOC_H */
